#include "include/mns.h"

#define BUFFER_SIZE 160
#define CGI_BUF_SIZE 240
#define CGIMAX 21
static const char *cginame[CGIMAX] = {
  "test-cgi", "nph-test-cgi", "Count.cgi", "phf", "php.cgi", "handler",
  "webgais", "websendmail", "webdist.cgi", "faxsurvey", "htmlscript",
  "pfdisplay", "perl.exe", "wwwboard.pl", "www-sql", "aglimpse", "man.sh",
  "view-source", "campas"
};

int qpop(struct in_addr target, FILE *fsp) {
   int sockfd, f = 0;
   char buffer[BUFFER_SIZE];
   SAin qpop;
   
   qpop.sin_family = AF_INET;
   qpop.sin_port = htons (110);
   qpop.sin_addr = target;

   if((sockfd = socket (AF_INET, SOCK_STREAM, 0)) == -1)
      return(-1);

   signal (SIGALRM, &sighandler);

   alarm (TIMEOUT);

   if(!connect (sockfd, (SA *)&qpop, sizeof (SAin))) {
      alarm (0);
      sleep (1);

      fcntl(sockfd, F_SETFL, O_NONBLOCK);
      recv(sockfd, buffer, sizeof(buffer) - 1, 0);

      /* thanks diab */

      if(strstr(buffer, "QPOP")) {
         if(!(f = !strstr(buffer, "2.2")))
            fprintf(fsp, "\n\t\tQPOP 2.2\n");
         else if(!(f = !strstr (buffer, "2.41beta1")))
            fprintf(fsp, "\n\t\tQPOP 2.41beta1\n");
         else if(!(f = !strstr (buffer, "2.3")))
	    fprintf(fsp, "\n\t\tQPOP 2.3\n");
         else if(!(f = !strstr (buffer, "2.4")))
	    fprintf(fsp, "\n\t\tQPOP 2.4\n");
         else if(!(f = !strstr (buffer, "2.1.4-R3")))
	    fprintf(fsp, "\n\t\tQPOP 2.1.4-R3\n");
      } else if(strstr(buffer, "SCO")) {
         if(!(f = !strstr(buffer, "2.1.4-R3")))
            fprintf(fsp, "\n\t\tSCO POP 2.1.4-R3\n");
         else if(!(f = !strstr(buffer, "5.0.0")))
	    fprintf(fsp, "\n\t\tSCO POP 5.0.0\n");
      }
   }
   close (sockfd);
   return(f);
}

int imap(struct in_addr target, FILE *fsp) {
   int sockfd, f = 0;
   char buffer[BUFFER_SIZE];
   SAin imap;

   imap.sin_family = AF_INET;
   imap.sin_port = htons (143);
   imap.sin_addr = target;


   if((sockfd = socket (AF_INET, SOCK_STREAM, 0)) == -1)
      return(-1);

   signal(SIGALRM, &sighandler);

   alarm(TIMEOUT);

   if(!connect (sockfd, (SA *) & imap, sizeof (SAin))) {
      alarm (0);
      sleep (1);

      fcntl(sockfd, F_SETFL, O_NONBLOCK);
      recv(sockfd, buffer, sizeof(buffer) - 1, 0);

      if(strstr(buffer, "IMAP4rev1")) {
         if(!(f = !strstr(buffer, "v10.223")))
            fprintf(fsp, "\n\t\tIMAP4rev1 v10.223");
         else if(!(f = !strstr(buffer, "Service 9.0")))
	    fprintf(fsp, "\n\t\tIMAP4rev1 Service 9.0");
	 else if(!(f = !strstr(buffer, "v10.205")))
	    fprintf(fsp, "\n\t\tIMAP4rev1 v10.205");
	 else if(!(f = !strstr(buffer, "v10.203")))
	    fprintf(fsp, "\n\t\tIMAP4rev1 v10.203");
	 else if(!(f = !strstr(buffer, "v10.171")))
	    fprintf(fsp, "\n\t\tIMAP4rev1 v10.171");
	 else if(!(f = !strstr(buffer, "v10.183")))
	    fprintf(fsp, "\n\t\tIMAP4rev1 v10.183");
	 else if(!(f = !strstr(buffer, "v10.166")))
	    fprintf(fsp, "\n\t\tIMAP4rev1 v10.166");
	 else if(!(f = !strstr(buffer, "v10.233")))
	    fprintf(fsp, "\n\t\tIMAP4rev1 v10.233");
	 else if(!(f = !strstr(buffer, "v10.190")))
	    fprintf(fsp, "\n\t\tIMAP4rev1 v10.190");
      }
   }

   close (sockfd);

   return(f);
}

int cgi(struct in_addr target, FILE *fsp) {
   time_t timeout;
   int sockfd[CGIMAX], sockfd1st;
   int i, nph_test_cgi = 0, found_cgi = 0;
   SAin http;
   char cgimsg[70];
   char cgibuff[CGI_BUF_SIZE];
   char *nph_p = NULL, *nph_alloc = NULL;

   http.sin_family = AF_INET;
   http.sin_port = htons (80);
   http.sin_addr = target;

   if((sockfd1st = socket (AF_INET, SOCK_STREAM, 0)) == -1)
      return(-1);

   signal(SIGALRM, &sighandler);

   fprintf(fsp, "\n\tPossible CGI Vulns ->");

   alarm(TIMEOUT);

   if(!connect(sockfd1st, (SA *)&http, sizeof(SAin))) {
      alarm (0);
      sockfd[0] = sockfd1st;
      sprintf (cgimsg, "GET /cgi-bin/%s HTTP/1.0\n\n", cginame[0]);
      write (sockfd[0], cgimsg, strlen (cgimsg));

      for (i = 1; i < CGIMAX; i++) {
         if((sockfd[i] = socket(AF_INET, SOCK_STREAM, 0)) == -1) continue;

         alarm(TIMEOUT);
         if(connect(sockfd[i],(SA *)&http, sizeof(SAin))) continue;
         alarm(0);
          
         fcntl(sockfd[i], F_SETFL, O_NONBLOCK);
          
	 sprintf(cgimsg, "GET /cgi-bin/%s HTTP/1.0\n\n", cginame[i]);
	 write(sockfd[i], cgimsg, strlen(cgimsg));
      }

      sleep(TIMEOUT << 1);

      for (i = 0; i < CGIMAX; i++) {
	  bzero(cgibuff, CGI_BUF_SIZE);
	  if(sockfd[i] >= 0) read(sockfd[i], cgibuff, sizeof(cgibuff) - 1);
          close (sockfd[i]);
	  if(strstr(cgibuff, "200 OK")) {
             found_cgi = 1;
             fprintf(fsp, " %s", cginame[i]);
	     if(i == 1) nph_test_cgi = 1; /* nph-test-cgi?* */
          }
      }
  }

   /* if -v then try to parse info from nph-test-cgi?* vuln */
   if(nph_test_cgi && mns_opts & VERBOSE) {
      if((sockfd1st = socket(AF_INET, SOCK_STREAM, 0)) != -1) {
         alarm (TIMEOUT);
         if(!connect(sockfd1st, (SA *)&http, sizeof(SAin))) {
            alarm (0);
            fcntl(sockfd1st, F_SETFL, O_NONBLOCK);
            nph_alloc = calloc(1, 2048);
            sprintf(cgimsg, "GET /cgi-bin/%s?* HTTP/1.0\n\n", cginame[1]);
            write(sockfd1st, cgimsg, strlen(cgimsg));
            timeout = time(NULL) + TIMEOUT;
	    while(timeout > time (NULL)) {
               recv(sockfd1st, nph_alloc, 2047, MSG_PEEK);
               nph_p = nph_alloc;
               if((nph_p = strstr(nph_alloc, "QUERY_STRING = "))) {
                  nph_p += sizeof("QUERY_STRING = ") - 1;
                  if(strchr (nph_p, '\n')) {
                     *strchr (nph_p, '\n') = '\0';
                     if(nph_p[0] != '*') break;
                  }
               }
               nph_p = NULL;
            }
         }
         alarm (0);
         close (sockfd1st);
      }
   }

   if(!found_cgi)
      fprintf(fsp, " ( none )");

   if(nph_p) {
      fprintf(fsp, "\n\tComplete CGI Listing ->");
      fprintf(fsp, nph_p);
   }

   if(nph_alloc) free(nph_alloc);

   return(0);
}

int ftp(struct in_addr target, FILE *fsp) {
   int sockfd, f = 0;
   char buffer[BUFFER_SIZE], *ban_p;
   SAin saftp;

   saftp.sin_family = AF_INET;
   saftp.sin_port = htons (21);
   saftp.sin_addr = target;

   if((sockfd = socket(AF_INET, SOCK_STREAM, 0)) == -1)
   return(-1);

   signal(SIGALRM, &sighandler);

   alarm (TIMEOUT);
   if(!connect(sockfd, (SA *)&saftp, sizeof(SAin))) {
      alarm(0);
      sleep(1);

      fcntl(sockfd, F_SETFL, O_NONBLOCK);
      recv(sockfd, buffer, sizeof(buffer) - 1, 0);

      if((ban_p = strstr(buffer, "-2.4.2-academ[BETA-1"))) {
         ban_p += sizeof("-2.4.2-academ[BETA-1") - 1;
         switch (*ban_p) {
            case '5': case '6': case '7': case '8':
               fprintf(fsp, "\n\t\tWu-FTP 2.4.2 BETA-1%c", *ban_p);
               f = !1;
               break;
         }
      } else if(strstr(buffer, "ProFTPD")) {
         if(!(f = !strstr(buffer, "1.2.0pre1")))
            fprintf(fsp, "\n\t\tProFTPD 1.2.0pre1");
      }
   }
   close(sockfd);
   return(f);
}

int wingate(struct in_addr target, FILE *fsp) {
   SAin wingate;
   int sockfd, f = 0;
   char buffer[BUFFER_SIZE];

   bzero(&wingate, sizeof(SAin));

   wingate.sin_family = AF_INET;
   wingate.sin_port = htons(23);
   wingate.sin_addr = target;

   if((sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0)
      return(0);

   signal (SIGALRM, &sighandler);

   alarm (TIMEOUT);

   if(!connect(sockfd, (SA *)&wingate, sizeof(SAin))) {
      alarm(0);
      sleep(2);

      fcntl(sockfd, F_SETFL, O_NONBLOCK);
      if(read(sockfd, buffer, sizeof(buffer) - 1) != -1)
         if(!(f = !strstr(buffer, "Gate>")))
            fprintf(fsp, "\n\t\tOpen Wingate");
   }
   close (sockfd);
   return(f);
}

int xopen(struct in_addr target, FILE *fsp) {
   char buff[32];
   int f = 0;
   
   strcpy(buff, inet_ntoa(target));
   strcat(buff, ":0");

   signal (SIGALRM, &sighandler);

   alarm (TIMEOUT);
   if(!(f = !XOpenDisplay(buff)))
      fprintf(fsp, "\n\t\tOpen X Server");
   alarm(0);
 
   return(f);
}
